.build: &build
  image:
    name: docker:19.03.13-dind
  only:
    - master
  script:
    - cp $GITLAB_SSH_PRIVATE_KEY ./gitlab-key
    - cp $GPG_PRIVATE_KEY ./gpg-secret.key
    - cp $GPG_OWNERTRUST ./gpg-ownertrust.txt
    - cp $MVN_SETTINGS_SECURITY ./settings-security.xml
    - docker build
      -t algeran/$IMAGE_NAME:$IMAGE_TAG
      --build-arg BASE_IMAGE=$IMAGE_NAME:$IMAGE_TAG
      --build-arg PASS_VERSION
      --build-arg OPENSSH_CLIENT_VERSION
      --build-arg GIT_VERSION
      --build-arg WGET_VERSION
      --build-arg GPG_VERSION
      --build-arg GITLAB_HOST
      --build-arg GIT_USER_EMAIL
      --build-arg GIT_USER_NAME
      --build-arg PASS_STORAGE_GIT_REPO
      .
    - docker push algeran/$IMAGE_NAME:$IMAGE_TAG

stages:
  - build

build:maven_image_java8:
  stage: build
  variables:
    IMAGE_NAME: maven
    IMAGE_TAG: 3.6.3-jdk-8
    PASS_VERSION: 1.7.3-2
    OPENSSH_CLIENT_VERSION: 1:7.9p1-10+deb10u2
    GIT_VERSION: 1:2.20.1-2+deb10u3
    WGET_VERSION: 1.20.1-1.1
    GPG_VERSION: 2.2.12-1+deb10u1
  <<: *build

build:maven_image_java11:
  stage: build
  variables:
    IMAGE_NAME: maven
    IMAGE_TAG: 3.6.3-jdk-11-slim
    PASS_VERSION: 1.7.3-2
    OPENSSH_CLIENT_VERSION: 1:7.9p1-10+deb10u2
    GIT_VERSION: 1:2.20.1-2+deb10u3
    WGET_VERSION: 1.20.1-1.1
    GPG_VERSION: 2.2.12-1+deb10u1
  <<: *build

build:maven_image_java14:
  stage: build
  variables:
    IMAGE_NAME: maven
    IMAGE_TAG: 3.6.3-openjdk-14-slim
    PASS_VERSION: 1.7.3-2
    OPENSSH_CLIENT_VERSION: 1:7.9p1-10+deb10u2
    GIT_VERSION: 1:2.20.1-2+deb10u3
    WGET_VERSION: 1.20.1-1.1
    GPG_VERSION: 2.2.12-1+deb10u1
  <<: *build
